{"swagger":"2.0","info":{"description":"API for the Dead Letter Topic (Queue) Utility, to enable DLT messages to be viewed, replayed and/or achieved.","version":"1.0.0","title":"10x DLT Utility API","contact":{"email":"sre@10xbanking.com"},"license":{"name":"Apache 2.0","url":"http://www.apache.org/licenses/LICENSE-2.0.html"}},"tags":[{"name":"dlt-controller","description":"Management of DLT messages"}],"paths":{"/dlt/register":{"post":{"tags":["dlt-controller"],"summary":"Registers a DLT with the Utility","operationId":"addInventory","description":"Adds an item to the system","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"dltDefinision","description":"Definision of the dead letter topic (queue)","schema":{"$ref":"#/definitions/DLTDefinision"}}],"responses":{"201":{"description":"item created"},"400":{"description":"invalid input, object invalid"},"409":{"description":"an existing item already exists"}}}},"/dlt":{"get":{"tags":["dlt-controller"],"summary":"Retrieves all registered dlt, providing the details of target replay topics and current sizes.","operationId":"getAllDlts","description":"By passing in the appropriate options, you can search for\navailable inventory in the system\n","produces":["application/json"],"responses":{"200":{"description":"search results matching criteria","schema":{"type":"array","items":{"$ref":"#/definitions/InventoryItem"}}},"400":{"description":"bad input parameter"}}}},"/dlt/{dlt-name}":{"get":{"tags":["dlt-controller"],"summary":"Gets the details of the DLT, including the list of messages identifier waiting to be processed","operationId":"getDlt","description":"By retrieving the contents of the next message on the DLT the reason for the message ending on the DLT can be determined \n","parameters":[{"name":"dlt-name","in":"path","type":"string","required":true}],"produces":["application/json"],"responses":{"200":{"description":"search results matching criteria","schema":{"type":"array","items":{"$ref":"#/definitions/InventoryItem"}}},"400":{"description":"bad input parameter"}}}},"/dlt/{topic-name}/{msg-id}":{"get":{"tags":["dlt-controller"],"summary":"Retrieves the contents of the dlt message as identifier by the message-identifier","operationId":"readDltMsg","description":"By retrieving the contents of the message the reason for the message ending on the DLT can often be determined \n","parameters":[{"name":"topic-name","in":"path","type":"string","required":true},{"name":"msg-id","in":"path","type":"string","required":true}],"produces":["application/json"],"responses":{"200":{"description":"search results matching criteria","schema":{"type":"array","items":{"$ref":"#/definitions/InventoryItem"}}},"400":{"description":"bad input parameter"}}}},"/dlt/{topic-name}/replay":{"post":{"tags":["dlt-controller"],"summary":"Processes all unprocessed DLT messages by forwarding them onto the replay topic defined during the registration call.","operationId":"replayBulk","description":"By retrieving the contents of the next message on the DLT the reason for the message ending on the DLT can be determined \n","parameters":[{"name":"topic-name","in":"path","type":"string","required":true}],"produces":["application/json"],"responses":{"200":{"description":"search results matching criteria","schema":{"type":"array","items":{"$ref":"#/definitions/InventoryItem"}}},"400":{"description":"bad input parameter"}}}},"/dlt/{topic-name}/archive":{"post":{"tags":["dlt-controller"],"summary":"Marks all unprocessed DLT messages on the topic specified as archived","operationId":"archiveBulk","description":"By retrieving the contents of the next message on the DLT the reason for the message ending on the DLT can be determined \n","parameters":[{"name":"topic-name","in":"path","type":"string","required":true}],"produces":["application/json"],"responses":{"200":{"description":"search results matching criteria","schema":{"type":"array","items":{"$ref":"#/definitions/InventoryItem"}}},"400":{"description":"bad input parameter"}}}},"/dlt/{topic-name}/{msg-id}/replay":{"post":{"tags":["dlt-controller"],"summary":"Processes the DLT message specified in the path by forwarding onto the replay topic defined during the registration call.","operationId":"replaySingleMsg","description":"By retrieving the contents of the next message on the DLT the reason for the message ending on the DLT can be determined \n","parameters":[{"name":"topic-name","in":"path","type":"string","required":true},{"name":"msg-id","in":"path","type":"string","required":true}],"produces":["application/json"],"responses":{"200":{"description":"search results matching criteria","schema":{"type":"array","items":{"$ref":"#/definitions/InventoryItem"}}},"400":{"description":"bad input parameter"}}}},"/dlt/{topic-name}/{msg-id}/archive":{"post":{"tags":["dlt-controller"],"summary":"Marks the DLT message specified in the path as archived.","operationId":"archiveSingleMsg","description":"By retrieving the contents of the next message on the DLT the reason for the message ending on the DLT can be determined \n","parameters":[{"name":"topic-name","in":"path","type":"string","required":true},{"name":"msg-id","in":"path","type":"string","required":true}],"produces":["application/json"],"responses":{"200":{"description":"search results matching criteria","schema":{"type":"array","items":{"$ref":"#/definitions/InventoryItem"}}},"400":{"description":"bad input parameter"}}}}},"definitions":{"DLTDefinision":{"type":"object","required":["name","description","replay-topic-name","runbook_url","causes"],"properties":{"name":{"type":"string","example":"card-clearing-dlt"},"description":{"type":"string","example":"Settlement messages which are unable to be processed are directed to this DLT."},"replay-topic-name":{"type":"string","example":"card-clearing-retry"},"runbook_url":{"type":"string","example":"https://confluence.10x.mylti3gh7p4x.net/pages/viewpage.action?spaceKey=SM&title=Schedule+Manager+-+On+Call+Runbook"},"causes":{"type":"string","example":"Unable to find card or subscription for a settlement transaction"}}},"Manufacturer":{"required":["name"],"properties":{"name":{"type":"string","example":"ACME Corporation"},"homePage":{"type":"string","format":"url","example":"https://www.acme-corp.com"},"phone":{"type":"string","example":"408-867-5309"}}}},"host":"virtserver.swaggerhub.com","basePath":"/Daniel.Oakes/10x-DeadLetterTopic-Utility/1.0.0","schemes":["https"]}